#ifndef _ball_hh_
#define _ball_hh_

#include "global.hh"
#define BALL_RADIUS 7


class Ball
{
  public:
  
  Ball();
  ~Ball();

  void Update();
  void Draw();
  void BrickBounce();


  Ball& operator = (const Ball& ball);

  int rad; // radius
  double x; // x coordinate
  double y; // y coordinate
  int oldx; // old x coordinate
  int oldy; // old y coordinate
  int g; // direction
  int speed;
  int stat;
  int bx;
  int ball;
  int time;

private:
  
  int CheckLR();
  int CheckUD();
  void BrickHit(int br);
 
};



class BallContainer
{
  public:
  
  BallContainer();
  ~BallContainer();

  Ball bv[MAX_BALLS];

  int Add(int x, int y);
  int Add(int x, int y,int g,int speed,int stat = 1,int bx = 0);
  void DeleteAll();
  void Update();
  void ChangeSpeed(int change);
  void ChangeDir();
  void LaunchAll();

};


#endif















