
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include "brick.hh"

int Brick :: LoadBricks(Brick *b)
{
  char n = 0;
  int fd = open(BRICKDIR, O_RDONLY);
  if (fd == 0) return fd;
  read(fd, (char*)&n, sizeof(char));
  for (int i = 0; i < n; i++)
  {
    read(fd, (char*)&b[i].name, sizeof(char[32]));
    read(fd, (char*)&b[i].strength, sizeof(strength));
    read(fd, (char*)&b[i].changeTo, sizeof(changeTo));
    read(fd, (char*)&b[i].bonus, sizeof(bonus));
    read(fd, (char*)&b[i].special, sizeof(special));
    read(fd, (char*)&b[i].sound, sizeof(sound));
    read(fd, (char*)&b[i].score, sizeof(score));
    read(fd, (char*)&b[i].x, sizeof(x));
    read(fd, (char*)&b[i].y, sizeof(y));
    read(fd, (char*)&b[i].needed, sizeof(needed));
    read(fd, (char*)&b[i].explosion, sizeof(explosion));
    read(fd, (char*)&b[i].mask, sizeof(mask));
  }
  close(fd);
  return n;
}

void Brick :: SaveBricks(Brick *b, char n)
{
  int fd = open(BRICKDIR, O_WRONLY | O_CREAT, S_IWUSR|S_IRUSR|S_IWGRP|S_IRGRP|S_IROTH|S_IWOTH);
  write(fd, (char*)&n, sizeof(char));
  for (int i = 0; i < n; i++)
  {
    write(fd, (char*)&b[i].name, sizeof(char[32]));
    write(fd, (char*)&b[i].strength, sizeof(strength));
    write(fd, (char*)&b[i].changeTo, sizeof(changeTo));
    write(fd, (char*)&b[i].bonus, sizeof(bonus));
    write(fd, (char*)&b[i].special, sizeof(special));
    write(fd, (char*)&b[i].sound, sizeof(sound));
    write(fd, (char*)&b[i].score, sizeof(score));
    write(fd, (char*)&b[i].x, sizeof(x));
    write(fd, (char*)&b[i].y, sizeof(y));
    write(fd, (char*)&b[i].needed, sizeof(needed));
    write(fd, (char*)&b[i].explosion, sizeof(explosion));
    write(fd, (char*)&b[i].mask, sizeof(mask));
  }
  close(fd);
}

Brick :: Brick()
{
  strcpy(name, "Untitled");
  strength = explosion = 1;
  y = x = score = changeTo = needed = 0;
  mask = special = sound = bonus = -1;
}

Brick :: ~Brick()
{
  name[0] = '\0';
}



