#include "declarations.hh"
#include "gfm.hh"

void btn_close_notify(Panel_item item, Event *event);
void btn_open_notify(Panel_item item, Event *event);

void btn_level_load_notify(Panel_item item, Event *event)
{
  rload = gfm_initialize(NULL, NULL, "Load Background");
  gfm_activate(rload, rasdir, "^.*\\.ras$", NULL, cbback, NULL, GFM_LOAD);
}


void btn_world_apply_notify(Panel_item item, Event *event)
{
  strcpy(props.n, (char*)xv_get(Led_win_world.txt_world_name, PANEL_VALUE));
  strcpy(props.a, (char*)xv_get(Led_win_world.txt_world_author, PANEL_VALUE));
  strcpy(props.c, (char*)xv_get(Led_win_world.txt_world_comment, PANEL_VALUE));
  world.SetProperties(props);
  xv_set(Led_win_main.list_world, PANEL_LIST_TITLE, props.n, NULL);
  strcpy(tmp, "World properties applied ok.");
  Message(Led_win_world.win_world, tmp);
  edited = 1;
}

void btn_world_reset_notify(Panel_item item, Event *event)
{
  led_win_world_objects *ip = (led_win_world_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
  xv_set(ip->txt_world_name, PANEL_VALUE, "", NULL);
  xv_set(ip->txt_world_author, PANEL_VALUE, "", NULL);
  xv_set(ip->txt_world_comment, PANEL_VALUE, "", NULL);
  DrawLevel();
  strcpy(tmp, "World properties reset ok.");
  Message(Led_win_world.win_world, tmp);
  edited = 1;
}


void btn_level_apply_notify(Panel_item item, Event *event)
{
  led_win_level_objects *ip = (led_win_level_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
  strcpy(props.n, (char*)xv_get(ip->txt_level_name, PANEL_VALUE));
  strcpy(props.a, (char*)xv_get(ip->txt_level_author, PANEL_VALUE));
  strcpy(props.c, (char*)xv_get(ip->txt_level_comment, PANEL_VALUE));
  strcpy(props.b, (char*)xv_get(ip->txt_level_background, PANEL_VALUE));
  props.f[0] = (int)xv_get(ip->slider_level_time, PANEL_VALUE);
  props.f[1] = (int)xv_get(ip->slider_level_increase, PANEL_VALUE);
  props.f[2] = (int)xv_get(ip->slider_level_speed, PANEL_VALUE);
  props.f[3] = (int)xv_get(Led_win_level.setting_alignment, PANEL_VALUE);
  world.SetLevelProperties(order[SELECTED], props);
  xv_set(Led_win_main.list_world, PANEL_LIST_STRING, SELECTED, props.n, NULL);
  strcpy(tmp, "Level properties applied ok.");
  Message(Led_win_level.win_level, tmp);
  strcpy(tmp, props.n); 
  strcat(tmp, " by "); 
  strcat(tmp, props.a);
  xv_set(Led_win_edit.win_edit, XV_LABEL, tmp, NULL);
  InitBackground(order[SELECTED]);
  DrawLevel();
  edited = 1;
}


void btn_level_reset_notify(Panel_item item, Event *event)
{
  led_win_level_objects *ip = (led_win_level_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
  xv_set(ip->txt_level_name, PANEL_VALUE, "", NULL);
  xv_set(ip->txt_level_author, PANEL_VALUE, "", NULL);
  xv_set(ip->txt_level_comment, PANEL_VALUE, "", NULL);
  xv_set(ip->txt_level_background, PANEL_VALUE, "", NULL);
  xv_set(ip->slider_level_time, PANEL_VALUE, 400, NULL);
  xv_set(ip->slider_level_increase, PANEL_VALUE, 50, NULL);
  xv_set(ip->slider_level_speed, PANEL_VALUE, 4, NULL);
  strcpy(tmp, "Level properties reset ok.");
  Message(Led_win_level.win_level, tmp);
  edited = 1;
}


void btn_open_notify(Panel_item item, Event *event)
{
  xv_set(Led_win_edit.win_edit, XV_SHOW, TRUE, NULL);
  world->LevelCopy(brick, order[SELECTED]);
  DrawLevel();

  for (int b = 0; b < 90; b++)
    pw_rop((Xv_opaque)bwin, (b%6)*MARK_WIDTH+3, (b/6)*MARK_HEIGHT+2,
	   BRICK_WIDTH, BRICK_HEIGHT, PIX_SRC,
	   bricks.pr, BRICK_WIDTH*(b%10), BRICK_HEIGHT*(b/10));

  xv_set(Led_win_main.btn_open, PANEL_LABEL_STRING, "C\0", 
	 PANEL_NOTIFY_PROC, btn_close_notify, NULL);
  xv_set(Led_win_bricks.win_bricks, XV_SHOW, TRUE, NULL);
}

void btn_close_notify(Panel_item item, Event *event)
{
  world->LevelCopy(order[SELECTED], brick);
  xv_set(Led_win_edit.win_edit, XV_SHOW, FALSE, NULL);
  xv_set(Led_win_bricks.win_bricks, XV_SHOW, FALSE, NULL);
  xv_set(Led_win_main.btn_open, PANEL_LABEL_STRING, "O\0", 
	 PANEL_NOTIFY_PROC, btn_open_notify, NULL);
}


void btn_next_notify(Panel_item item, Event *event)
{
  int row = SELECTED;
  if (row == NROWS-1)
    xv_set(Led_win_main.btn_next, PANEL_INACTIVE, TRUE, NULL);
  world->LevelCopy(order[row], brick);
  SELECT(SELECTED+1);
  SetLevels();
  world->GetLevelProperties(order[row], &props);
  InitBackground(order[row]);
  SetLevelProperties();
  world->LevelCopy(brick, order[row]);
  DrawLevel();
}

void btn_brick_apply_notify(Panel_item item, Event *event)
{
  led_win_props_objects *ip = (led_win_props_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);

  strcpy(brix[mark[1]].name, (char*)xv_get(ip->txt_brick_name, PANEL_VALUE));
  brix[mark[1]].sound = xv_get(ip->txt_brick_sound, PANEL_VALUE);
  brix[mark[1]].bonus = xv_get(ip->txt_brick_bonus, PANEL_VALUE);
  brix[mark[1]].strength = xv_get(ip->txt_brick_breakable, PANEL_VALUE);
  brix[mark[1]].changeTo = xv_get(ip->txt_brick_change_to, PANEL_VALUE);
  brix[mark[1]].special =xv_get(ip->txt_brick_special, PANEL_VALUE);
  brix[mark[1]].score =xv_get(ip->txt_brick_score, PANEL_VALUE);
  brix[mark[1]].needed =xv_get(ip->txt_brick_needed, PANEL_VALUE);
  brix[mark[1]].explosion =xv_get(ip->txt_brick_explosion, PANEL_VALUE);
  brix[mark[1]].mask =xv_get(ip->txt_brick_mask, PANEL_VALUE);
}

void btn_brick_reset_notify(Panel_item item, Event *event)
{
  led_win_props_objects *ip = (led_win_props_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);

}

void led_win_level_btn_level_dismiss_notify_callback(Panel_item item, Event *event)
{
  led_win_level_objects *ip = (led_win_level_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
  
  EnableMenuItem(Led_win_main.btn_level, "Properties");
  xv_set(Led_win_level.win_level, XV_SHOW, FALSE, NULL);
}

void led_win_world_btn_world_dismiss_notify_callback(Panel_item item, Event *event)
{
  led_win_world_objects *ip = (led_win_world_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
  
  EnableMenuItem(Led_win_main.btn_world, "Properties");
  xv_set(Led_win_world.win_world, XV_SHOW, FALSE, NULL);
}


void led_win_props_btn_brick_dismiss_notify_callback(Panel_item item, Event *event)
{
  xv_set(Led_win_props.win_props, XV_SHOW, FALSE, NULL);
}

void btn_brick_save_notify(Panel_item item, Event *event)
{
  for (int i = 0; i < 100; i++)
  {
    brix[i].x = i%10*BRICK_WIDTH;
    brix[i].y = int(i/10)*BRICK_HEIGHT;
  }
  brix->SaveBricks(brix, 100);
}
