#include "declarations.hh"
#include "gfm.hh"

//
//
// Callbacks
//
//

int cbload(gfm_popup_objects *ip, char *dir, char *file)
{
  xv_set(ip->popup, XV_SHOW, FALSE, NULL);
  xv_set(Led_win_main.btn_level, PANEL_INACTIVE, FALSE, NULL);
  xv_set(Led_win_main.btn_open, PANEL_INACTIVE, FALSE, NULL);
  delete world;

  EnableMenuItem(Led_win_main.btn_level, "Properties");
  EnableMenuItem(Led_win_main.btn_level, "Move");
  EnableMenuItem(Led_win_main.btn_level, "Delete");
  EnableMenuItem(Led_win_main.btn_world, "Save");
  EnableMenuItem(Led_win_main.btn_world, "Save as");
  EnableMenuItem(Led_win_main.btn_world, "Properties");

  strcpy(filename, file);
  world = new World;
  world->Load(file);
//  world->DumpAll(0);
  world->GetProperties(&props);
  SetWorldProperties();

  xv_set(Led_win_main.list_world, PANEL_LIST_TITLE, props.n, PANEL_INACTIVE, TRUE, XV_SHOW, TRUE, NULL);
  ClearList();
  
  for (int k = 0; k < world->Levels(); k++)
  {
    order[k] = k;
    world->GetLevelProperties(k, &props);
    xv_set(Led_win_main.list_world, PANEL_LIST_INSERT, k, PANEL_LIST_STRING, k, props.n, NULL);
  }
  xv_set(Led_win_main.list_world, PANEL_INACTIVE, FALSE, XV_SHOW, TRUE, NULL);

  SELECT(0);
  SetLevels();

  xv_set(Led_win_main.btn_open, PANEL_INACTIVE, FALSE, NULL);
  world->GetLevelProperties(0, &props);
  SetLevelProperties();
  world->LevelCopy(brick, 0);
  InitBackground(0);
  DrawLevel();
  strcpy(tmp, "World '");
  strcat(tmp, file);
  strcat(tmp, "' loaded ok."); 
  Message(Led_win_main.win_main, tmp);
  if (world->Levels() == 1)
    xv_set(Led_win_main.btn_next, PANEL_INACTIVE, FALSE, NULL);
}

// Load level

int cbloadl(gfm_popup_objects *ip, char *dir, char *file)
{
  xv_set(ip->popup, XV_SHOW, FALSE, NULL);

  uchar n, a = world->LoadLevel(file);

  world->Dump(a);
  cur = SELECTED;
  if (SELECTED == -1) cur = 0;
  world->LevelCopy(brick, a);
  n = NROWS;
  InsertOrder(a, n);
  world->GetLevelProperties(a, &props);

  SetLevelProperties();
  SetLevels();
  
  xv_set(Led_win_main.list_world, PANEL_LIST_INSERT, n, PANEL_LIST_STRING, n, props.n, NULL);
  SELECT(n);
  InitBackground(order[n]);
  
  if (NROWS > 1)
    EnableMenuItem(Led_win_main.btn_level, "Move");
  else
  {
    EnableMenuItem(Led_win_main.btn_level, "Properties");
    DisableMenuItem(Led_win_main.btn_level, "Move");
    EnableMenuItem(Led_win_main.btn_level, "Delete");
    xv_set(Led_win_main.btn_open, PANEL_INACTIVE, FALSE, NULL);
  }
  
  if (xv_get(Led_win_edit.win_edit, XV_SHOW) == TRUE)
  {
    world->LevelCopy(brick, n);
    DrawLevel();
    strcpy(tmp, props.n); 
    strcat(tmp, " by "); 
    strcat(tmp, props.a);
    xv_set(Led_win_edit.win_edit, XV_LABEL, tmp, NULL);
  }

  if (xv_get(Led_win_edit.win_edit, XV_SHOW) == TRUE)
    xv_set(Led_win_main.btn_open, PANEL_INACTIVE, TRUE, NULL);
  strcpy(tmp, "Level '");
  strcat(tmp, props.n);
  strcat(tmp, "' loaded ok."); 
  Message(Led_win_main.win_main, tmp);
  edited = 1;
}

int cbback(gfm_popup_objects *ip, char *dir, char *file)
{
  char f[255];
  if (strcmp(dir, "gfx/patterns"))
  {
    strcpy(f, dir);
    strcat(f, "/");
    strcat(f, file);
    strcpy(rasdir, dir);
  }
  else
  {
    strcpy(f, "gfx/patterns/");
    strcat(f, file);
  }
  xv_set(ip->popup, XV_SHOW, FALSE, NULL);
  xv_set(Led_win_level.txt_level_background, PANEL_VALUE, f, NULL);
}

int cbsave(gfm_popup_objects *ip, char *dir, char *file)
{
  EnableMenuItem(Led_win_main.btn_world, "Save");
  world->LevelCopy(order[SELECTED], brick);
  strcpy(filename, file);
  if (strstr(filename, ".world") == NULL)
    strcat(filename, ".world");
  xv_set(ip->popup, XV_SHOW, FALSE, NULL);
  world->Save(filename, order);
  strcpy(tmp, "World '");
  strcat(tmp, file);
  strcat(tmp, "' saved ok."); 
  Message(Led_win_main.win_main, tmp);
  edited = 0;
}

